import * as React from "react";
import * as PropTypes from "prop-types";
import { CancelTokenSource, AxiosError, AxiosResponse } from "axios";
import { TimerButtonContext } from "../TimerButton";
import { PhoneValidatorContext } from "../PhoneValidator";
import { AutoRequestProviderProps, AutoRequestProviderState, AutoRequestProviderContext } from "./AutoRequestProviderTypes";
export declare class AutoRequestProvider extends React.Component<AutoRequestProviderProps, AutoRequestProviderState> {
    static readonly defaultProps: {
        groupName?: string;
        phoneLength?: number;
        onBeforeRequest?: () => void;
        onFailRequest?: (error: AxiosError) => void;
        onSuccessRequest?: (response?: AxiosResponse<any>) => void;
        request?: (cancelToken: CancelTokenSource) => Promise<any>;
    };
    static readonly contextTypes: {
        readonly value?: PropTypes.Validator<any>;
        readonly addError: PropTypes.Validator<any>;
        readonly getError: PropTypes.Validator<any>;
        readonly getDOMElement: PropTypes.Validator<any>;
    };
    static readonly propTypes: {
        groupName: PropTypes.Validator<any>;
        phoneLength?: PropTypes.Validator<any>;
        onBeforeRequest?: PropTypes.Validator<any>;
        onFailRequest?: PropTypes.Validator<any>;
        onSuccessRequest?: PropTypes.Validator<any>;
        request: PropTypes.Validator<any>;
    };
    static readonly childContextTypes: {
        getStartTimerHandler: PropTypes.Validator<any>;
        getStopTimerHandler: PropTypes.Validator<any>;
        requestSmsToken: PropTypes.Validator<any>;
        onTimeout: PropTypes.Validator<any>;
        disabled: PropTypes.Validator<any>;
        onValidate: PropTypes.Validator<any>;
        onValidated: PropTypes.Validator<any>;
        groupName: PropTypes.Validator<any>;
    };
    readonly state: AutoRequestProviderState;
    readonly context: AutoRequestProviderContext;
    protected stopTimer?: () => void;
    protected startTimer?: () => void;
    getChildContext(): PhoneValidatorContext & TimerButtonContext;
    render(): React.ReactNode;
    componentWillUnmount(): void;
    protected getStopTimerHandler: (handler: () => void) => void;
    protected getStartTimerHandler: (handler: () => void) => void;
    protected requestSmsToken: () => Promise<void>;
    protected handleValidate: (nextValue: string, prevValue: string) => boolean;
    protected readonly shouldTimerBeDisabled: boolean;
    protected handleValidated: (isValid: boolean) => void;
    protected cancelRequest: () => void;
    private filterPhone;
}
