import * as PropTypes from "prop-types";
import { CancelTokenSource, AxiosError, AxiosResponse } from "axios";
import { ModelError } from "react-context-form";
export interface AutoRequestProviderState {
    cancelToken?: CancelTokenSource;
    isValid: boolean;
}
export interface AutoRequestProviderProps {
    groupName: string;
    phoneLength?: number;
    onBeforeRequest?: () => void;
    onFailRequest?: (error: AxiosError) => void;
    onSuccessRequest?: (response?: AxiosResponse<any>) => void;
    request: (cancelToken: CancelTokenSource) => Promise<any>;
}
export declare const AutoRequestProviderPropTypes: {
    [P in keyof AutoRequestProviderProps]: PropTypes.Validator<any>;
};
export declare const AutoRequestProviderDefaultProps: {
    [P in keyof AutoRequestProviderProps]?: AutoRequestProviderProps[P];
};
export interface AutoRequestProviderContext {
    readonly value?: string;
    readonly addError: (newError: ModelError) => void;
    readonly getError: (attribute: string) => ModelError | undefined;
    readonly getDOMElement: (attribute: string) => HTMLElement | undefined;
}
export declare const AutoRequestProviderContextTypes: {
    [P in keyof AutoRequestProviderContext]: PropTypes.Validator<any>;
};
