import * as React from "react";
import * as PropTypes from "prop-types";
export interface TimerButtonProps extends React.HTMLProps<HTMLButtonElement> {
    timerIcon?: JSX.Element;
    onTimeout?: () => void;
    waitTime?: number;
}
export interface TimerButtonContext {
    getStartTimerHandler: (handler: () => boolean) => void;
    getStopTimerHandler: (handler: () => void) => void;
    requestSmsToken: () => void;
    onTimeout: () => void;
    disabled: boolean;
}
export declare const TimerButtonContextTypes: {
    [P in keyof TimerButtonContext]: PropTypes.Validator<any>;
};
export declare const TimerButtonPropTypes: {
    [P in keyof TimerButtonProps]: PropTypes.Validator<any>;
};
export declare const TimerButtonDefaultProps: {
    [P in keyof TimerButtonProps]?: TimerButtonProps[P];
};
